package linprog;
import java.math.BigDecimal;

/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 *
 * @author
 * @version 2001.0
 */

 /**
 * This represents dih(S) A[y/2]
 * Bounded between 0 and 2Pi A[1].
 */
public class Adih extends Variable {

  private static final BigDecimal zero = new BigDecimal(0.0);
  private static final BigDecimal AdihMax = Parameters.I_twopi.multiply(Trig.A(Parameters.I_one,ParameterFactory.get().eM())).max();


  public Adih() {
    super(zero,AdihMax,"Adih");
  }

  public Adih(String id) {
    super(zero,AdihMax,"Adih"+id);
  }
}