package linprog;

/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 * Company:
 * @author Thomas C. Hales
 * @version 2001.0
 */
import java.math.BigDecimal;
 /**
 * This represents an angle of a region in the decomposition of the unit sphere.
 * All the data is held in a workspace.  The angle is bounded between 0 and 2Pi.
 */
public class Angle extends Variable {

  private static final BigDecimal zero = new BigDecimal(0.0);
  private static final BigDecimal boundTwoPi = new BigDecimal("6.284");


  public Angle() {
    super(zero,boundTwoPi,"alpha");
  }

  public Angle(String id) {
    super(zero,boundTwoPi,"alpha"+id);
  }
}