package graph.archive;
public class graphDispatch {

    // This class grabs archive strings from graph*.java.
    public final static int DODEC = 0, QUAD = 1, PENT = 2, HEX = 3, HEPT = 4, OCT = 5, MOREDODEC = 6;
    private final static int SERIESMAX = 6; // keep in sync with the highest value.
    /**
     * Grabs an archive string from the archive.
     * @param series int graphDispatch.DODEC,...,graphDispatch.OCT
     * @param graphNumber range 0..length-1 (java indexing).
     * if series or graphNumber is out of range, null is returned.
     */

    public static String getArchiveString(int series, int graphNumber) {
        String[] data = null;
        switch(series) {
            case DODEC:
                data = dodec.data;
                break;

            case MOREDODEC:
                data = dodecMore.data;
                break;

            case QUAD:
                data = graphQ.data;
                break;

            case PENT:
                data = graphPENT.data;
                break;

            case HEX:
                data = graphHEX.data;
                break;

            case HEPT:
                data = graphHEPT.data;
                break;

            case OCT:
                data = graphOCT.data;
                break;

            default:
                return null;
        }
        if(graphNumber < 0 || graphNumber >= data.length)
            return null;
        return data[graphNumber];
    }

    /**
     * gives the number of graphs in a given series.
     * @param series int graphDispatch.DODEC,...,graphDispatch.OCT.
     */

    public static int size(int series) {
        switch(series) {
            case DODEC:
                return dodec.data.length;

            case MOREDODEC:
                return dodecMore.data.length;

            case QUAD:
                return graphQ.data.length;

            case PENT:
                return graphPENT.data.length;

            case HEX:
                return graphHEX.data.length;

            case HEPT:
                return graphHEPT.data.length;

            case OCT:
                return graphOCT.data.length;
        }
        return 0;
    }

    public static void main(String[] args) {
        for(int i = 0;i <= SERIESMAX;i++)
            System.out.println("size " + i + " " + size(i));
    }
}
