package linprog;
import util.*;
import java.io.*;
import java.util.*;

/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 *
 * @author
 * @version 2001.0
 */

 /**
  * The class ParseIneq is so large that we have moved the testcode into a separate class.
  */

public class ParseIneqTest {

  private static String fileName = "test.data"; // "test.data";

  public ParseIneqTest() {
  }

  public static class TestCode extends UnitTest {
    static String testData="";
    static {
      try {
        testData = IO.getString(Parameters.ineqPath+fileName);
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }

    public void testTokenizer() {
      ParseIneq P = new ParseIneq(testData);
      PeekIterator I = P.Tokenize();
      StringBuffer B = new StringBuffer();
      while (I.hasNext()) {
        Token T = (Token) I.next();
        B.append(T.toString());
      }
      String expected = "{CHAR,[}{SYMBOL,y1}{CHAR,,}{SYMBOL,y2}"; // etc.
      assert(B.substring(0,expected.length()).equals(expected));

    }

    public void testNode() {
      ParseIneq P = new ParseIneq(testData);
      PeekIterator I = P.Tokenize();
      Node N = P.parseDomain3(I);
      // spaces will be removed for easier comparison
      String expected = "<Domain3size='3'><DomainVarsize='6'><Symbolsize='1'>y1</Symbol>"; //etc.
      String found = N.toString();
      StringBuffer B = new StringBuffer();
      assert(found.length()>= expected.length());
      for (int i=0;i<found.length();i++) {
        char c = found.charAt(i);
        if (c!='\n' && c!=' ' && c!='\t') {
          B.append(c);
        }
      }
      found = B.substring(0,expected.length());
      assert(found.equals(expected),found);
    }

    public void testIneq() {
      ParseIneq P = new ParseIneq(testData);
      PeekIterator I = P.Tokenize();
      try {
      Node N = P.parseInequalityList(I);
      //System.out.println(N.toString());
      }
      catch (Exception e) {
        assert(false,"failed to parse the file "+fileName);
      }
    }

   }

}