package linprog;

/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 *
 * @author
 * @version 2001.0
 */


import java.math.BigDecimal;

/**
 * This represents the score of a face.
 * The upper bound for a face is 1 pt.
 */
public class Sigma extends Variable {

  private static final BigDecimal m20 = new BigDecimal(-20.0);
  private static final BigDecimal pt = Parameters.I_pt.max();

  public Sigma() {
    super(m20,pt,"sigma");
  }

  public Sigma(String id) {
    super(m20,pt,"sigma"+id);
  }

}