package linprog;
import ilog.cplex.example.CpxProblem;
import java.util.*;

/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 * Company:
 * @author Thomas C. Hales
 * @version 2001.0
 */

/**
 * represents the objective function of a linear program.
 */
public class Objective extends CoefficientList {

  private int sense;

  /**
   * @param sense CpxProblem.Maximize or CpxProblem.Minimize
   */
  public void setSense(int sense) {
    this.sense = sense;
  }

  public int getSense() {
    return sense;
  }

  public Objective() {
    super();
  }

  public String toString() {
    StringBuffer buf = new StringBuffer();
    switch(sense) {
      case CpxProblem.Maximize : buf.append("MAXIMIZE"); break;
      case CpxProblem.Minimize : buf.append("MINIMIZE"); break;
      default : buf.append("UNKNOWN"); break;
    }
    buf.append('\n');
    buf.append(super.toString());
    /**
    for (Iterator I=this.getVariableIterator();I.hasNext();){
      Variable V = (Variable)I.next();
      Interval coeff = this.getCoefficient(V);
      buf.append("["+coeff.toString()+" * "+V.toString()+ " ]  ");
    }
    **/
    return buf.toString();
  }


}