package linprog;
import java.math.BigDecimal;


/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 * Company:
 * @author Thomas C. Hales
 * @version 2001.0
 */

public class ParameterKepler implements Parameters {

  public ParameterKepler() {
  }

  private static final String[] ineqFileList = new String[] {"ineq.txt"};
  public String[] ineqFiles() {
    return ineqFileList;
  }

  public Interval edgeMax() {
    return eMc;
  }
  public Interval eM() {
    return eMc;
  }
  private static final Interval eMc =  new Interval("2.51");
  /**
   * edgeMax/2
   */
  public Interval trunc() {
    return tr;
  }
  private static final Interval tr = eMc.divide(Parameters.I_two);

  /**
   * Lower bound on the number of vertices.
   */
  public int vertexMinCount() {
    return 0;
  }

  public static Interval pt = new Interval("0.055373645668463869730","1.0e-14");
  private static Interval pt8 = pt.multiply(new BigDecimal(8.0));
  public Interval scoreTarget() {
    return pt8;
  }

  private final static Interval I_017 = new Interval("0.017","0");

  public static class Test extends util.UnitTest {

  }


}