package linprog;
import java.util.*;
import util.*;

/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 *
 * @author
 * @version 2001.0
 */

 /**
  * This is a generic class that has nothing to do with the linprog class.
  * This is like an iterator, except that that there is a peek function that doesn't
  * advance the iteration.
  */
public class PeekIterator implements Iterator {

  boolean hasPeeked = false;
  Object peek=null;
  Iterator I;
  public PeekIterator(Iterator I) {
    this.I = I;
  }
  public Object peek() {
    if (hasPeeked) return peek;
    hasPeeked= true;
    peek = I.next();
    return peek;
  }
  public boolean hasNext() {
    return hasPeeked || I.hasNext();
  }
  public Object next() {
    if (hasPeeked) {
      hasPeeked=false;
      return peek;
    }
    return I.next();
  }
  public void remove() {
    throw new java.lang.UnsupportedOperationException();
  }

  public static class TestCode extends UnitTest {
    public void test() {
      ArrayList A = new ArrayList();
      A.add("A");
      A.add("B");
      A.add("C");
      A.add("D");
      Iterator it = A.iterator();
      PeekIterator I = new PeekIterator(it);
      assert(I.hasNext());
      assert(I.peek().equals("A"));
      assert(I.peek().equals("A"));
      assert(I.next().equals("A"));
      assert(I.next().equals("B"));
      assert(I.peek().equals("C"));
      assert(I.next().equals("C"));
      assert(I.hasNext());
      assert(I.peek().equals("D"));
      assert(I.hasNext());
      assert(I.next().equals("D"));
      assert(!I.hasNext());
    }
  }

}