package linprog;
import java.math.BigDecimal;
import java.util.Hashtable;
/**
 * Title:        KeplerConjecture 2001
 * Description:  Licensed under GNU GPL http://www.gnu.org/copyleft/gpl.html
 * Copyright:    Copyright (c) 2001, Thomas C. Hales
 * Company:
 * @author Thomas C. Hales
 * @version 2001.0
 */

/**
 * Represents a variable in a linear programming problem.  Each variable has
 * an associated lower and upper bound.  Variables are immutable.
 */
public class Variable {

  private String name;
  private BigDecimal lowerBound;
  private BigDecimal upperBound;


  public Variable(BigDecimal lowerBound, BigDecimal upperBound, String name) {
    this.name = name;
    this.lowerBound = lowerBound;
    this.upperBound = upperBound;
  }

    public Variable(BigDecimal lowerBound, BigDecimal upperBound) {
      this(lowerBound,upperBound,"XX");
    }

  public String toString() {
    return name;
  }

  public BigDecimal getUpperBound() {
    return upperBound;
  }

  public BigDecimal getLowerBound() {
    return lowerBound;
  }
}